Imports System.Security.Principal


Module Module1

    Sub Main()
        Dim id As WindowsIdentity = GetWindowsIdentity("bob", ".", "secret")

        DoImpersonatedWork(id)

    End Sub

    Private Function GetWindowsIdentity(ByVal username As String, ByVal authority As String, ByVal password As String) As WindowsIdentity
        Dim token As IntPtr = IntPtr.Zero
        NativeMethods.LogonUser(username, authority, password, LogonType.LOGON32_LOGON_INTERACTIVE, ProviderType.LOGON32_PROVIDER_DEFAULT, token)

        If token = IntPtr.Zero Then
            Throw New Exception("Falsche Credentials")
        End If

        Dim id As WindowsIdentity = New WindowsIdentity(token)
        NativeMethods.CloseHandle(token)

        Return id
    End Function

    Sub DoImpersonatedWork(ByVal id As WindowsIdentity)
        Console.WriteLine("Vor der Impersonierung: {0}", WindowsIdentity.GetCurrent.Name)

        Using id.Impersonate()
            Console.WriteLine("Whrend der Impersonierung: {0}", WindowsIdentity.GetCurrent.Name)
        End Using

        Console.WriteLine("Nach der Impersonierung: {0}", WindowsIdentity.GetCurrent.Name)
    End Sub
End Module
